
/* Functions are ordered as in the htmlpluginfo struct */

#include <hildon-widgets/hildon-defines.h>
#include <osso-log.h>
/* TODO: remove those libxml ?? or any other? */
#include <libxml/xmlerror.h>
#include <libxml/uri.h>
#include <libxml/parser.h>
#include <libxml/HTMLparser.h>

#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <time.h>
#include "../common.h"
#include "../htmlview.h"
#include "../support.h"
#include "../callbacks.h"
#include "../update.h"
#include "../debug.h"
#include "../dbus.h"
#include "../appdata.h"
#include "../ui_itemlist.h"



#define FONT_SIZE 14
#define DEFAULT_FONT_SIZE 17
#define FOCUS_BORDER_X 20
#define FOCUS_BORDER_Y 0


//GtkWidget * gtkhtml_htmlview; //the scroll pane
//gchar * rendered_content; //to be used externally
void gtkhtml_init();

void gtkhtml_deinit();
GtkWidget *gtkhtml_new();
void gtkhtml_write_html(GtkWidget * widget, const gchar * string, gchar * base, nodePtr node);
void gtkhtml_stop();

//void gtkhtml_handle_net_connect(GSList *request_list);
//void gtkhtml_handle_net_error(GSList * reqest_list);

void gtkhtml_handle_net_connect(void);
void gtkhtml_handle_net_error(void);
//void gtkhtml_handle_net_connect(struct request *req);
//void gtkhtml_handle_net_error(struct request * req);

//void gtkhtml_launch_url(GtkWidget * widget, const gchar * url);
//gboolean gtkhtml_launch_inside_possible(void);
/* separate func for search feed */
void gtkhtml_start_write_search_feed(nodePtr node);
void gtkhtml_finish_search_feed(void);


void gtkhtml_zoom_in();
void gtkhtml_zoom_out();

gfloat gtkhtml_get_zoom_level(GtkWidget * scrollpane);
void gtk_html_change_the_zoom_level(GtkWidget * scrollpane, gfloat level);
gboolean gtkhtml_scroll_pagedown(GtkWidget * scrollpane);
gboolean gtkhtml_scroll_to_item(nodePtr ptr, guint32 nr);
gboolean gtkhtml_jump_to_next_focusable_object (gboolean jump_down);
gchar * gtkhtml_render_empty_feed(void);
/**Note: This func is supposed to be used by any feed
 * only needed for search feed, as normal feeds 
 * can be done using gtkhtml stream 
*/
void gtkhtml_searchview_append_item (itemPtr ip); 
gchar * gtkhtml_render_head(feedPtr fd);

void gtkhtml_append_and_display_item(itemPtr ip);
void gtkhtml_display_empty_feed(feedPtr fp);

//menu_edit

gboolean htmlwidget_has_selection( GtkWidget *scrollpane );
void htmlwidget_copy_selection( GtkWidget * scrollpane );
void gtkhtml_selectall(void);

gboolean gtkhtml_find_cb( GtkWidget *scrollpane,
                       const gchar *str, 
                       gboolean rewind, 
                       gboolean *retval_ref );
                       
void gtkhtml_grab_cond_focus(gboolean forward);
