/**
 * @file ui_popup.c popup menus
 *
 * Copyright (C) 2003 Lars Lindner <lars.lindner@gmx.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#include "feed.h"
#include "folder.h"
#include "support.h"
#include "callbacks.h"
#include "htmlview.h"
#include "ui_popup.h"
#include "ui_mainwindow.h"
#include "update.h"

/* from callbacks.c */
extern gboolean itemlist_mode;

#define TOGGLE_CONDENSED_VIEW    "/Condensed View"

#define TOGGLE_WORK_OFFLINE     "/Work Offline"
#define TOGGLE_SHOW_WINDOW      "/Show Window"

/************************************************************************/
/*                        PUBLIC FUNCTIONS                              */
/************************************************************************/

gboolean on_mainfeedlist_button_press_event(GtkWidget * widget,
                        GdkEventButton * event,
                        gpointer user_data)
{
    GdkEventButton *eb = NULL;
    GtkWidget *treeview = NULL;
    GtkTreeModel *model = NULL;
    GtkTreePath *path = NULL;
    GtkTreeIter iter;
    gboolean selected = TRUE;
    nodePtr node = NULL;

    treeview = feedlist;
    //g_assert(treeview);
    g_return_val_if_fail ((treeview != NULL), FALSE);

    if (event->type != GDK_BUTTON_PRESS)
    return FALSE;

    eb = (GdkEventButton *) event;

    if (eb->button != 3)
    return FALSE;

    if (!gtk_tree_view_get_path_at_pos
    (GTK_TREE_VIEW(feedlist), event->x, event->y, &path, NULL, NULL,
     NULL)) {
    selected = FALSE;
    } else {
    model = gtk_tree_view_get_model(GTK_TREE_VIEW(feedlist));
    gtk_tree_model_get_iter(model, &iter, path);
    gtk_tree_model_get(model, &iter, FS_PTR, &node, -1);
    if (node != NULL)
        ui_feedlist_select(node);
    else            /* This happens when an "empty" node is clicked */
        selected = FALSE;
    gtk_tree_path_free(path);
    }

    return TRUE;
}
